import { Subject } from 'rxjs';
import { ChangeDetectorRef, ElementRef, InjectionToken } from '@angular/core';
import { CanDisableCtor } from '@angular/material/core';
import { Direction } from '../../models/direction.enum';
import { IScrollableElement } from '../../models/scrollable-element.model';
import { ISelectElement } from '../../models/select-element.model';
import { BrowserService } from '../../services/browser/browser.service';
import { DirectionService } from '../../services/direction/direction.service';
export declare const SELECT_ELEMENT: InjectionToken<ISelectElement>;
declare class SimpleOptionBase {
}
declare const _SimpleSelectMixinBase: CanDisableCtor & typeof SimpleOptionBase;
export declare class OptionComponent extends _SimpleSelectMixinBase implements IScrollableElement {
    private cdRef;
    private browser;
    private dirService;
    private parent;
    label?: string;
    value: any;
    dir?: 'ltr' | 'rtl' | 'auto';
    get id(): string;
    set id(value: string);
    element: ElementRef;
    content: ElementRef;
    highlight: Subject<void>;
    select: Subject<void>;
    Direction: typeof Direction;
    get text(): string;
    get html(): string;
    get isRTL(): boolean;
    get direction(): Direction;
    get highlighted(): boolean;
    set highlighted(highlighted: boolean);
    selected: boolean;
    hovered: boolean;
    overflowOffset: number;
    scrollSideways: boolean;
    private _id;
    private _highlighted;
    private uid;
    private clientWidth;
    constructor(cdRef: ChangeDetectorRef, browser: BrowserService, dirService: DirectionService, parent: ISelectElement);
    shouldScrollSideways(): boolean;
    startFunctionality(): void;
    stopFunctionality(): void;
    calculateScroll(): void;
}
export {};
