import { AfterViewInit, ChangeDetectorRef, ElementRef, QueryList, DoCheck, OnDestroy } from '@angular/core';
import { ControlValueAccessor, FormGroupDirective, NgControl, NgForm } from '@angular/forms';
import { CanDisable, CanDisableCtor, CanUpdateErrorState, CanUpdateErrorStateCtor, ErrorStateMatcher, HasTabIndex, HasTabIndexCtor } from '@angular/material/core';
import { Direction } from '../../models/direction.enum';
import { IInteractiveList } from '../../models/interactive-list.model';
import { IScrollableList } from '../../models/scrollable-list.model';
import { BrowserService } from '../../services/browser/browser.service';
import { DeviceService } from '../../services/device/device.service';
import { ListKeyManager } from '../a11y/key-manager/list-key-manager';
import { ListScrollManager } from '../a11y/scroll-manager/list-scroll-manager';
import { OptionComponent } from '../option/option.component';
declare class SimpleSelectBase {
    _elementRef: ElementRef;
    _defaultErrorStateMatcher: ErrorStateMatcher;
    _parentForm: NgForm;
    _parentFormGroup: FormGroupDirective;
    ngControl: NgControl;
    constructor(_elementRef: ElementRef, _defaultErrorStateMatcher: ErrorStateMatcher, _parentForm: NgForm, _parentFormGroup: FormGroupDirective, ngControl: NgControl);
}
declare const _SimpleSelectMixinBase: CanDisableCtor & HasTabIndexCtor & CanUpdateErrorStateCtor & typeof SimpleSelectBase;
export declare class SelectComponent extends _SimpleSelectMixinBase implements ControlValueAccessor, DoCheck, CanDisable, HasTabIndex, CanUpdateErrorState, IScrollableList, IInteractiveList, AfterViewInit, OnDestroy {
    private cdRef;
    private browser;
    device: DeviceService;
    ngControl: NgControl;
    placeholder?: string;
    dir?: 'ltr' | 'rtl' | 'auto';
    errorStateMatcher: ErrorStateMatcher;
    private _ariaLabel?;
    get id(): string;
    set id(id: string);
    get value(): object | string | number;
    set value(value: object | string | number);
    get hoverBorder(): boolean;
    set hoverBorder(hoverBorder: boolean);
    get animate(): boolean;
    set animate(animateVal: boolean);
    get required(): boolean;
    set required(required: boolean);
    get showUI(): boolean;
    get showArrowAnimation(): boolean;
    get showList(): boolean;
    get selected(): OptionComponent;
    get direction(): Direction;
    get ariaLabel(): string | null;
    get activeDescendant(): string | null;
    get elements(): OptionComponent[];
    set elements(options: OptionComponent[]);
    list: ElementRef;
    options: QueryList<OptionComponent>;
    Direction: typeof Direction;
    focus: boolean;
    mouseOver: boolean;
    selectedIndex: number;
    highlightedIndex: number;
    scrollManager: ListScrollManager;
    keyManager: ListKeyManager;
    private _id;
    private _value;
    private _hoverBorder;
    private _animate;
    private _required;
    private _elements;
    private optionSubscriptions;
    private uid;
    private readonly destroy;
    constructor(cdRef: ChangeDetectorRef, browser: BrowserService, device: DeviceService, elementRef: ElementRef, _defaultErrorStateMatcher: ErrorStateMatcher, _parentForm: NgForm, _parentFormGroup: FormGroupDirective, ngControl: NgControl, tabIndex: string);
    skipPredicateFn: (item: OptionComponent) => boolean;
    propagateChange: (_: any) => void;
    propagateTouched: () => void;
    startFunctionality(): void;
    stopFunctionality(): void;
    mouseenter(): void;
    mouseleave(): void;
    scrolledOutsideSelect(): void;
    blur(): void;
    renderedList(): void;
    selectIndex(index: number): void;
    highlightIndex(index: number): void;
    initOptions(): void;
    emit(): void;
    writeValue(value: any): void;
    registerOnChange(fn: () => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState?(isDisabled: boolean): void;
    ngAfterViewInit(): void;
    updateOptions(): void;
    ngDoCheck(): void;
    ngOnDestroy(): void;
}
export {};
